unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, db, memds, FileUtil, Forms, Controls, Graphics,
  Dialogs, DBGrids, Menus;

type
    THackGrid = class(TCustomDBGrid)
public
  property Row;
  property TopRow;
end;

type

  { TForm1 }

  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    MemDataset1: TMemDataset;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PopupMenu1: TPopupMenu;
    procedure DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
   i: integer;
begin
     for i:=1 to 100 do
     begin
          Self.MemDataset1.Append;

          Self.MemDataset1.FieldByName('field1').AsInteger:=i;
          Self.MemDataset1.FieldByName('field2').AsString:='field2-' + IntToStr(i);
          Self.MemDataset1.FieldByName('field3').AsString:='field3-' + IntToStr(i);
          Self.MemDataset1.FieldByName('field4').AsString:='field4-' + IntToStr(i);


          Self.MemDataset1.Post;
     end;

end;

procedure TForm1.DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
   col, row: integer;
   hackGrid: THackGrid absolute Sender;
begin

     if Button=mbRight then
     begin
       DBGrid1.MouseToCell(X, Y, col, row);
       if row>0 then
       begin
            DBGrid1.DataSource.DataSet.DisableControls;
            DBGrid1.DataSource.DataSet.RecNo := DBGrid1.DataSource.DataSet.RecNo - hackGrid.Row + row;
            DBGrid1.DataSource.DataSet.EnableControls;
            Self.PopupMenu1.PopUp;
       end;
     end;

end;

end.

